


$TITLE(87C054 DEMO DRIVER Program)
$MOD51
$DEBUG
$INCLUDE(\WGH\MTV.DEF)

STRTOP	BIT	0

; RAM locations used

SECS	   DATA	   26H	
DCOUNT     DATA    27H
HCOUNT	   DATA	   28H
OSMOD1     DATA	   29H
OSMOD2     DATA    2AH
			
;CONSTANTS USED

OSCON	EQU	0C0H
OSORG	EQU	0C2H
OSMOD	EQU	0C1H
OSAD	EQU	09AH
OSDT	EQU	099H
OSAT	EQU	098H
TON	EQU	27H
TOFF	EQU	17H
VSYNC	EQU	0C7H

;*****************************************************************************
;                                Begin Code
;*****************************************************************************


OSDGO:	MOV	OSCON,#58H
	MOV	OSORG,#2FH
	MOV	OSAD,#0
	MOV	OSMOD,#27H
	MOV	DPTR,#OSDMSG
	CALL	OSDFIL
	CALL	FTTB
	MOV	SECS,#4
	CALL	DELAY
	CALL	EBTT
	MOV	DPTR,#SCRN1
	CALL	OSDFIL
	CALL	FTTB
	MOV	SECS,#2
	CALL	DELAY
	CALL	EBTT

	MOV	DPTR,#SCRN2
	CALL	OSDFIL
	MOV	OSMOD1,#0A7H
	MOV	OSMOD2,#97H
	CALL	FTTB1
	MOV	SECS,#4
	CALL	DELAY
	CALL	EBTT
	MOV	DPTR,#SCRN3
	CALL	OSDFIL
	CALL	FTTB
	CALL	EBTT
	MOV	DPTR,#SCRN4
	CALL	OSDFIL
	CALL	FTTB
	CALL	EBTT
	MOV	DPTR,#SCRN5
	CALL	OSDFIL
	MOV	OSMOD,#TON
	MOV	SECS,#3
	CALL	DELAY
	MOV	OSORG,#27H
	MOV	SECS,#1
	CALL	DELAY
	MOV	OSORG,#47H
	MOV	SECS,#1
	CALL	DELAY
	MOV	OSORG,#87H
	MOV	SECS,#1
	CALL	DELAY
	MOV	OSORG,#10H
	MOV	SECS,#1
	CALL	DELAY
	MOV	OSORG,#13H
	MOV	SECS,#1
	CALL	DELAY
	MOV	OSORG,#15H
	MOV	SECS,#1
	CALL	DELAY
	MOV	OSORG,#27H
	MOV	SECS,#1
	CALL	DELAY
	MOV	DPTR,#SHAD0
	MOV	OSMOD,#20H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD1
	MOV	OSMOD,#21H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD2
	MOV	OSMOD,#22H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD3
	MOV	OSMOD,#23H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD4
	MOV	OSMOD,#24H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD5
	MOV	OSMOD,#25H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD6
	MOV	OSMOD,#26H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SHAD7
	MOV	OSMOD,#27H
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	OSMOD,#TOFF
	MOV	DPTR,#QUAD
	CALL	OSDFIL
	MOV	OSCON,#5AH
	MOV	OSMOD,#TON
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#DBLH
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	OSCON,#58H
	MOV	OSORG,#27H
	MOV	DPTR,#DBLHW
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	OSORG,#2FH
	MOV	DPTR,#SRTROW
	CALL	OSDFIL
	MOV	SECS,#3
	CALL	DELAY
	MOV	DPTR,#SCRN1
	CALL	OSDFIL
	MOV	SECS,#0AH
	CALL	BLINK
	MOV	DPTR,#FONT
	CALL	OSDFIL
	SJMP	$

OSDFIL:	MOV	OSAD,#0	
	JNB	VSYNC,$
	CLR	VSYNC
	JNB	VSYNC,$
	CLR	VSYNC
FILMO:	CLR	A
	MOVC	A,@A+DPTR
	INC	DPTR
	JB	ACC.6,FILEND
	JNB	ACC.7,ISDAT
ISAT:	MOV	OSAT,A
	AJMP	FILMO
ISDAT:	MOV	OSDT,A
	AJMP	FILMO
FILEND:	MOV	OSAT,A
	CLR	A
	MOVC	A,@A+DPTR
	MOV	OSDT,A		;THIS SHOULD END IT
	RET


FTTB:	MOV	OSMOD1,#TON
	MOV	OSMOD2,#TOFF
FTTB1:	SETB	STRTOP
	CALL	WIPE
	MOV	OSMOD,#TON
	RET

FBTT:	MOV	OSMOD1,#TOFF
	MOV	OSMOD2,#TON
	CLR	STRTOP
	CALL	WIPE
	MOV	OSMOD,#TON
	RET

ETTB:	MOV	OSMOD1,#TOFF
	MOV	OSMOD2,#TON
	SETB	STRTOP
	CALL	WIPE
	MOV	OSMOD,#TOFF
	RET


EBTT:	MOV	OSMOD1,#TON
	MOV	OSMOD2,#TOFF
	CLR	STRTOP
	CALL	WIPE
	MOV	OSMOD,#TOFF
	RET

WIPE:	MOV	HCOUNT,#0FFH
	MOV	TMOD,#05H
WAITVS:	JNB	VSYNC,$
	CLR	VSYNC
	MOV	OSMOD,OSMOD1
	CLR	TR0
	MOV	A,HCOUNT
	JB	STRTOP,STOP	
	CPL	A
	INC	A
STOP:	MOV	TL0,A
	MOV	TH0,#0FFH
	SETB	TR0
WAITHS:	JNB	TF0,$
	CLR	TF0
	CPL	P2.0
	MOV	OSMOD,OSMOD2
	DJNZ	HCOUNT,WAITVS
	RET

;delay loop based on vertical sync
;requires number of secs be passed in variable "SECS"

DELAY:	MOV	DCOUNT,#3CH	;decimal 60 = 1 sec
DLP1:	JNB	VSYNC,$
	CLR	VSYNC
	DJNZ	DCOUNT,DLP1
	DJNZ	SECS,DELAY
	RET

BLINK:	MOV	DCOUNT,#1EH
BLP1:	JNB	VSYNC,$
	CLR	VSYNC
	DJNZ	DCOUNT,BLP1
	MOV	OSMOD,#TOFF
	MOV	DCOUNT,#1EH
BLP2:	JNB	VSYNC,$
	CLR	VSYNC
	DJNZ	DCOUNT,BLP2
	MOV	OSMOD,#TON
	DJNZ	SECS,BLINK
	RET

OSDMSG:
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+RED
	DB	SPACE,SPACE,SPACE,SPACE
	DB	?P,?H,?I,?L,?I,?P,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+BLUE
	DB	SPACE,SPACE,SPACE
	DB	?C,?O,?M,?P,?O,?N,?E,?N,?T,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+GREEN
	DB	SPACE,SPACE,SPACE
	DB	?S,?I,?G,?N,?E,?T,?I,?C,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+CYAN
	DB	SPACE,SPACE
	DB	?P,?R,?O,?G,?R,?A,?M,?M,?A,?B,?L,?E
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+MAGENTA
	DB	SPACE,SPACE,SPACE
	DB	?O,?N,DASH,?S,?C,?R,?E,?E,?N
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+BLACK
	DB	?M,?I,?C,?R,?O,?C,?0,?N,?T,?R,?O,?L,?L,?E,?R
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO+RED
	DB	SPACE
	DB	?8,?7,?C,?0,?5,?4
	DB	ATRIB
	DB	NEWL
	DB	3CH,3CH,3CH,3CH,90H,3EH,91H,3EH
	DB	92H,3EH,93H,3EH,94H,3EH,95H,3EH
	DB	96H,3EH,97H,3EH,80H
	DB	ATRIB+OSDEND
	DB	NEWL

SCRN1:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
;	DB	ATRIB+VIDEO
;	DB	SPACE
	DB	ATRIB+WHITE+VIDEO
	DB	3EH	;BKGND SPACE
	DB	ATRIB+RED+BKCLR
	DB	?R,?A,?D,?I,?O
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
;	DB	ATRIB+VIDEO
;	DB	SPACE
	DB	ATRIB+WHITE+VIDEO
	DB	3EH
	DB	ATRIB+RED+BKCLR
	DB	?S,?H,?A,?C,?K
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	NEWL
	DB	ATRIB+VIDEO
;	DB	SPACE,SPACE
	DB	SPACE,SPACE
	DB	ATRIB+BLUE+BKCLR
	DB	?A,?M,?E,?R,?I,?C,?A,APOS,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO
	DB	SPACE,SPACE
;	DB	SPACE,SPACE
	DB	ATRIB+BLUE+BKCLR
	DB	?T,?E,?C,?H,?N,?O,?L,?O,?G,?Y
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+VIDEO
	DB	SPACE,SPACE
;	DB	SPACE,SPACE
	DB	ATRIB+BLUE+BKCLR
	DB	?S,?T,?O,?R,?E
	DB	ATRIB+OSDEND
	DB	NEWL

SCRN2:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE+VIDEO
	DB	3EH	;BKGND SPACE
	DB	ATRIB+RED
	DB	?1,?2,?8,SPACE,?C,?H,?A,?R,?A,?C,?T,?E,?R,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+RED
	DB	?O,?N,SPACE,?S,?C,?R,?E,?E,?N,SPACE,?D,?I,?S,?P,?L,?A,?Y
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+BLUE
	DB	?1,?4,SPACE,?D,?0,?T,SPACE,?X,SPACE,?1,?8,SPACE,?L,?I,?N,?E,
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+BLUE
	DB	?C,?H,?A,?R,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+GREEN
	DB	?8,SPACE
	DB	ATRIB+BLACK,?F,ATRIB+RED,?O,ATRIB+GREEN,?R,ATRIB+YELLOW
	DB	?E,ATRIB+BLUE,?G,ATRIB+MAGENTA,?R,ATRIB+CYAN,?N
	DB	ATRIB+WHITE,?D,ATRIB+MAGENTA
	DB	BSPACE,ATRIB+BLACK+BKCLR,?C,?O,?L,?O,?R,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	?8,SPACE
	DB	ATRIB+CYAN,?B,ATRIB+MAGENTA,?A,ATRIB+BLUE,?C,ATRIB+YELLOW
	DB	?K,ATRIB+GREEN,?G,ATRIB+RED,?R,ATRIB+BLACK,?N
	DB	ATRIB+WHITE,?D,ATRIB+BLACK
	DB	BSPACE,ATRIB+MAGENTA+BKCLR,?C,?O,?L,?O,?R,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+BLUE+VIDEO
	DB	BSPACE
	DB	ATRIB+CYAN+BKCLR
	DB	SPACE,SPACE
	DB	?6,?4,ATRIB+RED+BKCLR,SBSPACE,ATRIB+MAGENTA+BKCLR,?C,?H,?A,?R
	DB	ATRIB+GREEN+BKCLR,SBSPACE,ATRIB+YELLOW+BKCLR,?F,?O,?N,?T
	DB	ATRIB+OSDEND
	DB	NEWL

SCRN3:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE+BKCLR
	DB	BSPACE,ATRIB+RED+BKCLR
	DB	?8,?0,?C,?5,?1,SPACE,?C,?O,?R,?E
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+GREEN+BKCLR
	DB	SPACE,?1,?6,?K,?B,SPACE,?C,?O,?D,?E,SPACE,?R,?O,?M
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+BLUE+BKCLR
	DB	?1,?9,?2,SPACE,?X,?8,SPACE,?D,?A,?T,?A,SPACE,?R,?A,?M
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+CYAN+BKCLR
	DB	?T,?W,?0,SPACE,?T,?I,?M,?E,?R,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?8,SPACE,?6,DASH,?B,?I,?T,SPACE,?P,?W,?M,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+YELLOW+BKCLR
	DB	?1,SPACE,?1,?4,DASH,?B,?I,?T,SPACE,?P,?W,?M
	DB	ATRIB+OSDEND
	DB	NEWL

SCRN4:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE+BKCLR
	DB	BSPACE,ATRIB+YELLOW+BKCLR
	DB	?9,SPACE,?D,?E,?D,?I,?C,?A,?T,?E,?D
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+YELLOW+BKCLR
	DB	?I,SLASH,?O,SPACE,?P,?I,?N,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?2,?8,SPACE,?G,?E,?N,?E,?R,?A,?L
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?I,SLASH,?O,SPACE,?P,?I,?N,?S
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	NEWL
	DB	ATRIB+CYAN+BKCLR
	DB	?S,?O,?F,?T,?W,?A,?R,?E,SPACE,?A,SLASH,?D
	DB	ATRIB+OSDEND
	DB	NEWL


SCRN5:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE+BKCLR
	DB	BSPACE,ATRIB+MAGENTA+BKCLR
	DB	?P,?R,?O,?G,?R,?A,?M,?M,?A,?B,?L,?E
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+CYAN+BKCLR
	DB	?H,?O,?R,?I,?Z,?O,?N,?T,?A,?L
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?A,?N,?D
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+GREEN+BKCLR
	DB	?V,?E,?R,?T,?I,?C,?A,?L
	DB	ATRIB+MAGENTA+BKCLR
	DB	SPACE,?S,?T,?A,?R,?T
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?P,?O,?S,?I,?T,?I,?O,?N,?S
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD0:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?0	
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD1:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?1	
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD2:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?2	
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD3:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?3	
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD4:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?4	
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD5:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?5
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD6:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?6	
	DB	ATRIB+OSDEND
	DB	NEWL

SHAD7:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?S,?H,?A,?D,?O,?W,SPACE,?7	
	DB	ATRIB+OSDEND
	DB	NEWL

DBLH:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+MAGENTA
	DB	?D,?O,?U,?B,?L,?E,SPACE,?H,?E,?I,?G,?H,?T
	DB	ATRIB+OSDEND
	DB	NEWL

DBLHW:	DB	ATRIB+SHADOW+DBLROW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+MAGENTA
	DB	?D,?O,?U,?B,?L,?E
	DB	ATRIB+SHADOW+DBLROW
	DB	NEWL
	DB	ATRIB+MAGENTA
	DB	SPACE,?H,?E,?I,?G,?H,?T
	DB	ATRIB+SHADOW+DBLROW
	DB	NEWL
	DB	ATRIB+MAGENTA
	DB	SPACE,SPACE,?A,?N,?D
	DB	ATRIB+SHADOW+DBLROW
	DB	NEWL
	DB	ATRIB+MAGENTA
	DB	SPACE,?W,?I,?D,?T,?H
	DB	ATRIB+OSDEND
	DB	NEWL

SRTROW:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+GREEN
	DB	?S,?H,?O,?R,?T,SPACE,?R,?O,?W,?S,SPACE,?F,?O,?R 
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+BLUE
	DB	?U,?N,?D,?E,?R,?L,?I,?N,?I,?N,?G
	DB	ATRIB+SHADOW+SHORT
	DB	NEWL
	DB	ATRIB+CYAN+BKCLR
	DB	BOX,BOX,BOX,BOX,BOX,BOX
	DB	BOX,BOX,BOX,BOX,BOX
	DB	ATRIB+OSDEND
	DB	NEWL


FONT:	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+WHITE
	DB	BSPACE
	DB	ATRIB+GREEN
	DB	0,1,2,3,4,5,6,7,8,9,0AH,0BH,0CH,0DH,0EH
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+BLUE
	DB	0FH,10H,11H,12H,13H,14H,15H,16H,17H,18H,19H,1AH,1BH,1CH,1DH
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+CYAN+BKCLR
	DB	1EH,1FH,20H,21H,22H,23H,24H,25H,26H,27H,28H,29H,2AH,2BH,2CH
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+RED+SHADOW
	DB	2DH,2EH,2FH,30H,31H,32H,33H,34H,35H,36H,37H,38H,39H,3AH,3BH
	DB	ATRIB+SHADOW
	DB	NEWL
	DB	ATRIB+CYAN+BKCLR
	DB	3CH
	DB	ATRIB+OSDEND
	DB	NEWL

QUAD:	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?Q,?U,?A,?D
	DB	ATRIB+DBLROW+SHADOW
	DB	NEWL
	DB	ATRIB+MAGENTA+BKCLR
	DB	?H,?E,?I,?G,?H,?T
	DB	ATRIB+OSDEND
	DB	NEWL


	END



